#include "editor.h"

//map_field clipboard;
map_square clipboard[40][40]; // FIXMEFIXME: Needs to be variably sized
int clipboard_x=0, clipboard_y=0;

//{{{
void get_selected_region(int *top, int *left, int *right, int *bottom)
{
	if(cursor_x==select_x && cursor_y==select_y) // If no selection, operate
	                                             // on the whole map
	{
		*top = *left = 0;
		*right = FIELD_WIDTH-1;
		*bottom = FIELD_HEIGHT-1;
	} else {
		*top = min(cursor_y, select_y);
		*bottom = max(cursor_y, select_y);
		*left = min(cursor_x, select_x);
		*right = max(cursor_x, select_x);
	}
}
//}}}

//{{{
void edit_cut(void)
{
	int top, bottom, left, right;
	int xi, yi;
	
	get_selected_region(&top, &left, &right, &bottom);
	
	clipboard_y = bottom-top+1;
	clipboard_x = right-left+1;
	for(yi=top; yi<=bottom; yi++)
	for(xi=left; xi<=right; xi++) {
		clipboard[yi-top][xi-left] = current_map->t[yi][xi];
		current_map->t[yi][xi] = TILE_EMPTY;
	}
}
//}}}
//{{{
void edit_copy(void)
{
	int top, bottom, left, right;
	int xi, yi;
	
	get_selected_region(&top, &left, &right, &bottom);
	
	clipboard_y = bottom-top+1;
	clipboard_x = right-left+1;
	for(yi=top; yi<=bottom; yi++)
	for(xi=left; xi<=right; xi++)
		clipboard[yi-top][xi-left] = current_map->t[yi][xi];
}
//}}}
//{{{
void edit_paste(void)
{
	int xi, yi;
	for(yi=0; yi<clipboard_y; yi++)
	for(xi=0; xi<clipboard_x; xi++)
	{
		if(yi+cursor_y>=FIELD_HEIGHT || xi+cursor_x>=FIELD_WIDTH)
			continue;
		current_map->t[yi+cursor_y][xi+cursor_x] = clipboard[yi][xi];
	}
}
//}}}
//{{{
void edit_clear(void)
{
	int top, bottom, left, right;
	int xi, yi;
	
	get_selected_region(&top, &left, &right, &bottom);
	
	for(yi=top; yi<=bottom; yi++)
	for(xi=left; xi<=right; xi++)
		current_map->t[yi][xi] = TILE_EMPTY;
}
//}}}
//{{{
void edit_select_all(void)
{
	select_x = select_y = 0;
	cursor_x = FIELD_WIDTH-1;
	cursor_y = FIELD_HEIGHT-1;
}
//}}}


