/* main.c */
void __main(void);
void initialize(void);
/* util.c */
int read_char(void);
void clear_screen(void);
void clear_line_range(int top, int bottom);
void draw_sprite(const char *spr, int x, int y);
void draw_sprite_xor(const char *spr, int x, int y);
void draw_line(short x0, short y0, short x1, short y1, short Attr);
void draw_string(const char *str, short x, short y);
void draw_string_font(const char *str, short x, short y, short font);
void clear_rect(int left, int top, int width, int height);
void draw_rect(int left, int top, int width, int height);
void xor_rect(int left, int top, int width, int height);
void debug_print(const char *fmt, ...);
int is_in_bounds(int x, int y);
char *freadstr(char *s, int n, FILE *fp);
void fwritestr(const char *s, FILE *fp);
/* palette.c */
void enter_palette_state(void);
void draw_palette_cursor(void);
void move_palette_cursor(int dd);
void palette_state(int key);
/* editor.c */
void initialize_editor(void);
void initialize_map(editor_map *M);
void cleanup_map(editor_map *M);
void set_level_size(int level, int width, int height);
void set_num_maps(int n);
void set_current_map(int n);
void enter_edit_state(void);
void clear_map(void);
void default_map(void);
void draw_current_map(void);
void draw_map_field(void);
void draw_map_tile(int x, int y);
void xor_tile(int x, int y);
void xor_selected_range(void);
void draw_editor_brush(void);
void draw_level_number(void);
void place_tile(int x, int y, int brush);
void editing_state(int key);
void move_cursor(int dx, int dy, int shifted);
/* menu.c */
void enter_menu_state(int menu);
void draw_menu_labels(void);
void undraw_open_menus(void);
void draw_open_menu(void);
void menu_toggle_highlight(int menu);
void switch_menu(int menu);
void menu_state(int key);
/* dialog.c */
int show_dialog(const char *message, int x, int y, int width, int height);
int dialog_read_string(const char *message, char *buffer, int x, int y, int width, int height);
/* file.c */
void file_new(void);
void file_open(void);
void file_save(void);
void file_save_as(void);
void file_exit(void);
int load_kyelib(const char *filename);
int load_dckye_lib(FILE *fin);
int load_skye_lib(FILE *fin, file_header *header);
int load_skye_lib_r1(FILE *fin, file_header *header);
int load_skye_level_r1(FILE *fin, int level);
int load_skye_lib_r2(FILE *fin, file_header *header);
int load_skye_level_r2(FILE *fin, int level);
int load_dckye_level(FILE *fin, int level);
int save_skyelib_r2(const char *filename);
void write_skye_level_r2(FILE *fout, int level);
/* transform.c */
void transform_mirror_horizontal(void);
void transform_mirror_vertical(void);
void transform_rotate_180(void);
int mirror_x(int t);
int mirror_y(int t);
int tile_is_wall(int x, int y);
void transform_smooth(void);
/* edit.c */
void get_selected_region(int *top, int *left, int *right, int *bottom);
void edit_cut(void);
void edit_copy(void);
void edit_paste(void);
void edit_clear(void);
void edit_select_all(void);
/* map.c */
void map_properties(void);
void map_resize(void);
void map_next(void);
void map_previous(void);
void map_import_level(void);
void map_insert(void);
void map_delete(void);
void map_move_up(void);
void map_move_down(void);
/* tiles.c */
/* properties.c */
void enter_properties_state(void);
void redraw_properties(void);
void properties_state(int key);
void apply_property_changes(void);
void switch_focus(int focus);
void key_textbox(struct widget *this, int key);
void draw_textbox(struct widget *this);
/* resize.c */
void enter_resize_state(void);
void draw_resize_dialog(void);
void resize_state(int key);
void adjust_map_size(int width, int height);
void clip_scroll_pos(void);
