
//{{{
int tile_is_wall(int x, int y)
{
	if(!is_in_bounds(x,y)) return 0;
	switch(current_map->t[y][x])
	{
		case TILE_WALL: case TILE_WALL_1: case TILE_WALL_2:
		case TILE_WALL_3: case TILE_WALL_4: case TILE_WALL_6:
		case TILE_WALL_7: case TILE_WALL_8: case TILE_WALL_9:
			return 1;
		default:
			return 0;
	}
}
//}}}
//{{{
int wall_map[16] =
// Bit N in an index into wall_map corresponds to whether relative position N 
// contains a wall or not.
//     +---+
//     |   |
//     | 1 |
//     |   |
// +---+---+---+
// |   |###|   |
// | 0 |###| 2 |
// |   |###|   |
// +---+---+---+
//     |   |
//     | 3 |
//     |   |
//     +---+
	{
	// Position 0 clear
		// Position 1 clear
			// Position 2 clear
			TILE_WALL,  // Position 3 clear
			TILE_WALL8, // Position 3 set
			// Position 2 set
			TILE_WALL4,  // Position 3 clear
			TILE_WALL7, // Position 3 set
		// Position 1 set
			// Position 2 clear
			TILE_WALL2, // Position 3 clear
			TILE_WALL,  // Position 3 set
			// Position 2 set
			TILE_WALL1, // Position 3 clear
			TILE_WALL,  // Position 3 set
	// Position 0 set
		// Position 1 clear
			// Position 2 clear
			TILE_WALL6, // Position 3 clear
			TILE_WALL9, // Position 3 set
			// Position 2 set
			TILE_WALL,  // Position 3 clear
			TILE_WALL,  // Position 3 set
		// Position 1 set
			// Position 2 clear
			TILE_WALL3, // Position 3 clear
			TILE_WALL,  // Position 3 set
			// Position 2 set
			TILE_WALL,  // Position 3 clear
			TILE_WALL,  // Position 3 set
	};
//}}}
//{{{
void transform_smooth(void)
{
	int xi, yi;
	int dirs[4];
	
	for(yi=0; yi<FIELD_HEIGHT; yi++)
	for(xi=0; xi<FIELD_WIDTH; xi++)
	{
		if(!tile_is_wall(xi, yi)) continue;
		dirs[0] = tile_is_wall(xi-1, yi);
		dirs[1] = tile_is_wall(xi, yi-1);
		dirs[2] = tile_is_wall(xi+1, yi);
		dirs[3] = tile_is_wall(xi, yi+1);
		current_map->t[yi][xi] = wall_map[ dirs[0]<<3 | dirs[1]<<2 | dirs[2]<<1 | dirs[3] ];
	}
}
//}}}


