#include "engine.h"

#define SET_MENU_LEFT  98
#define SET_MENU_WIDTH 60

//{{{
int pick_set(void)
{
	SYM_ENTRY *SymPtr;
	int num_files = 0;
	int num_files_alloced = 8;
	int retval = 1;
	char temp_filename[32]; // Temporary storage for filenames whilst malloc
	                        // is unsafe
	int top, height, ii, selection, input;
	char **ftab = (char**)malloc_throw(num_files_alloced * sizeof(char**));
	static int is_first_time = 1;
	
	FolderOp(SYMSTR("\x7F") , FOP_LOCK);
	
	// Build list of SKye files
//	SymPtr = FFindFirst(FO_RECURSE, "SKye", NULL);
	SymPtr = SymFindFirst(SYMSTR(""), FO_RECURSE);
	
	while(SymPtr)
	{
		strcpy(temp_filename, SymFindFolderName());
		strcat(temp_filename, "\\");
		strcat(temp_filename, SymPtr->name);
		if(match_extension(temp_filename, "SKye"))
		{
			if(num_files+1 >= num_files_alloced) {
				num_files_alloced += 8;
				ftab = (char**)realloc_throw(ftab,
				                          num_files_alloced * sizeof(char**));
			}
			ftab[num_files] = (char*)alloca( strlen(temp_filename)+1 );
			strcpy(ftab[num_files], temp_filename);
			num_files++;
		}
//		SymPtr = FFindNext();
		SymPtr = SymFindNext();
	}
	
	FolderOp(SYMSTR("\x7F") , FOP_UNLOCK);
	
	clear_screen();
	
	if(num_files==0) {
		draw_string("No levels found!", 20, 40, F_6x8);
		read_char();
		retval = 0;
		goto ret;
	}
	if(num_files==1) {
		strcpy(active_set, ftab[0]);
		retval = is_first_time; // If there's one level set, this menu
		                        // shouldn't be revisited
		goto ret;
	}
	
	// Show splash info left of menu
	draw_string("SKye", 25, 15, F_8x10);
	draw_string(VERSION_STRING, 32, 26, F_4x6);
	draw_string("By Jim Babcock", 13, 35, F_4x6);
	draw_string("Based on Kye by Dillon", 5, 47, F_4x6);
	draw_string("Collins and on Kye by", 5, 54, F_4x6);
	draw_string("Colin Garbutt.", 5, 61, F_4x6);
	
	
	// Show menu
	height = num_files*6 + 2;
	top = 50-(height/2);
	draw_rect(SET_MENU_LEFT, top, SET_MENU_WIDTH, height);
	for(ii=0; ii<num_files; ii++)
		draw_string(ftab[ii], SET_MENU_LEFT+2, top + 1 + ii*6, F_4x6);
	selection = 0;
	
	xor_rect(SET_MENU_LEFT+1, top+1+selection*6,
			 SET_MENU_WIDTH-2, 6);
	do
	{
		input = read_char();
		xor_rect(SET_MENU_LEFT+1, top+1+selection*6,
				 SET_MENU_WIDTH-2, 6);
		
		if       (input == KEY_DOWN) {
			selection++;
			selection %= num_files;
		} else if(input == KEY_UP) {
			if(selection==0) selection = num_files-1;
			else selection--;
		} else if(input == KEY_ENTER) {
			strcpy(active_set, ftab[selection]);
			goto ret;
		} else if(input == KEY_ESC) {
			strcpy(active_set, ftab[selection]);
			retval = 0;
			goto ret;
		}
		
		xor_rect(SET_MENU_LEFT+1, top+1+selection*6,
				 SET_MENU_WIDTH-2, 6);
	} while(1);
	
ret:
	if(ftab) free(ftab);
	is_first_time = 0;
	return retval;
}
//}}}

//{{{
int match_extension(const char *filename, const char *typename)
{
	FILE *fin = fopen(filename, "rb");
	unsigned char ftype;
	int len;
	char type[8];
	int ret = 0;
	
	if(!fin) return 0;
	
	len = strlen(typename);
	if(len>=8) len = 7;
	
	fseek(fin, -1, SEEK_END);
	ftype = fgetc(fin);
	
	if(ftype == OTH_TAG) {
		fseek(fin, -(strlen(typename)+2), SEEK_CUR);
		fread(type, strlen(typename)+1, 1, fin);
		if(!strcmp(type, typename))
			ret = 1;
	}
	
	fclose(fin);
	return ret;
}
//}}}
