/* main.c */
void __main(void);
void initialize(void);
void show_title_screen(void);
int show_splash(void);
void message(const char *message);
/* tiles.c */
/* util.c */
int read_char(void);
int read_char_with_timeout(void);
int poll_char(void);
void flush_input(void);
void delay(void);
void clear_screen(void);
void clear_line_range(int top, int bottom);
void draw_sprite(const char *spr, int x, int y);
void draw_sprite_xor(const char *spr, int x, int y);
void draw_line(short x0, short y0, short x1, short y1, short Attr);
void draw_string(const char *str, short x, short y, short font);
void clear_rect(int left, int top, int width, int height);
void draw_rect(int left, int top, int width, int height);
void xor_rect(int left, int top, int width, int height);
void freadstr(char *s, int n, FILE *fp);
unsigned short fread_fast(void *ptr, short size, short n, FILE *f);
short fseek_fast(FILE *f, long offset, short wh);
/* game.c */
void game_loop(void);
int level_advance(int level);
int make_move(int key);
void kye_move(int dx, int dy);
void scroll_viewport(void);
void center_viewport(void);
void draw_current_map(void);
void draw_map_tile(int x, int y);
void redraw_status_bar(void);
void advance(void);
int tile_is_monster(int x, int y);
void turn_sliders(void);
void try_rotate(int x, int y, int dx, int dy, int cw, int ccw);
void move_slider(int x, int y, int slippery, int dx, int dy);
int rotate_cw(int tile);
int rotate_ccw(int tile);
void move_pusher(int x, int y, int dx, int dy);
void move_monster(int x, int y);
effect_info animate_monster(int x, int y);
void detonate(int x, int y);
void clear_effects(void);
int is_in_bounds(int x, int y);
int can_shove(int x, int y, int dx, int dy);
void shove(int x, int y, int dx, int dy);
int check_diamonds(void);
void set_magnet_skips(void);
void restart_level(void);
void begin_level(void);
/* files.c */
int load_kyelib(int levelnum);
int load_skye_level(FILE *fin);
void set_level_size(int width, int height);
/* load.c */
int pick_set(void);
int match_extension(const char *filename, const char *typename);
